Index: kernel/arch/sparc64/include/types.h
===================================================================
--- kernel/arch/sparc64/include/types.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/sparc64/include/types.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -36,5 +36,7 @@
 #define KERN_sparc64_TYPES_H_
 
-#define NULL	0
+#define NULL 0
+#define false 0
+#define true 1
 
 typedef signed char int8_t;
@@ -48,4 +50,8 @@
 typedef unsigned long uint64_t;
 
+typedef uint64_t size_t;
+typedef uint64_t count_t;
+typedef uint64_t index_t;
+
 typedef uint64_t uintptr_t;
 typedef uint64_t pfn_t;
@@ -56,6 +62,10 @@
 typedef int64_t native_t;
 
-typedef struct pte pte_t;
+typedef uint8_t bool;
+typedef uint64_t task_id_t;
+typedef uint32_t context_id_t;
 
+typedef int32_t inr_t;
+typedef int32_t devno_t;
 typedef uint8_t asi_t;
 
Index: kernel/arch/sparc64/src/console.c
===================================================================
--- kernel/arch/sparc64/src/console.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/sparc64/src/console.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -35,5 +35,4 @@
 #include <arch/console.h>
 #include <arch/types.h>
-#include <typedefs.h>
 
 #include <arch/drivers/scr.h>
Index: kernel/arch/sparc64/src/cpu/cpu.c
===================================================================
--- kernel/arch/sparc64/src/cpu/cpu.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/sparc64/src/cpu/cpu.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -33,12 +33,9 @@
  */
 
-#include <arch/asm.h>
 #include <cpu.h>
 #include <arch.h>
+#include <genarch/ofw/ofw_tree.h>
+#include <arch/drivers/tick.h>
 #include <print.h>
-#include <arch/register.h>
-#include <genarch/ofw/ofw_tree.h>
-#include <arch/types.h>
-#include <arch/drivers/tick.h>
 
 /** Perform sparc64 specific initialization of the processor structure for the
Index: kernel/arch/sparc64/src/ddi/ddi.c
===================================================================
--- kernel/arch/sparc64/src/ddi/ddi.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/sparc64/src/ddi/ddi.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -36,5 +36,4 @@
 #include <proc/task.h>
 #include <arch/types.h>
-#include <typedefs.h>
 
 /** Enable I/O space range for task.
Index: kernel/arch/sparc64/src/drivers/fhc.c
===================================================================
--- kernel/arch/sparc64/src/drivers/fhc.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/sparc64/src/drivers/fhc.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -42,8 +42,7 @@
 #include <arch/drivers/fhc.h>
 #include <arch/trap/interrupt.h>
-#include <arch/mm/page.h>
+#include <mm/page.h>
 #include <mm/slab.h>
 #include <arch/types.h>
-#include <typedefs.h>
 #include <genarch/ofw/ofw_tree.h>
 
Index: kernel/arch/sparc64/src/drivers/kbd.c
===================================================================
--- kernel/arch/sparc64/src/drivers/kbd.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/sparc64/src/drivers/kbd.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -45,5 +45,4 @@
 #include <arch/mm/page.h>
 #include <arch/types.h>
-#include <typedefs.h>
 #include <align.h>
 #include <func.h>
Index: kernel/arch/sparc64/src/drivers/pci.c
===================================================================
--- kernel/arch/sparc64/src/drivers/pci.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/sparc64/src/drivers/pci.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -38,8 +38,7 @@
 #include <genarch/ofw/ofw_tree.h>
 #include <arch/trap/interrupt.h>
-#include <arch/mm/page.h>
+#include <mm/page.h>
 #include <mm/slab.h>
 #include <arch/types.h>
-#include <typedefs.h>
 #include <debug.h>
 #include <print.h>
Index: kernel/arch/sparc64/src/drivers/scr.c
===================================================================
--- kernel/arch/sparc64/src/drivers/scr.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/sparc64/src/drivers/scr.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -38,5 +38,4 @@
 #include <genarch/fb/visuals.h>
 #include <arch/types.h>
-#include <typedefs.h>
 #include <func.h>
 #include <align.h>
Index: kernel/arch/sparc64/src/drivers/tick.c
===================================================================
--- kernel/arch/sparc64/src/drivers/tick.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/sparc64/src/drivers/tick.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -35,7 +35,7 @@
 #include <arch/drivers/tick.h>
 #include <arch/interrupt.h>
+#include <arch/sparc64.h>
 #include <arch/asm.h>
 #include <arch/register.h>
-#include <typedefs.h>
 #include <arch/cpu.h>
 #include <arch/boot/boot.h>
Index: kernel/arch/sparc64/src/mm/as.c
===================================================================
--- kernel/arch/sparc64/src/mm/as.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/sparc64/src/mm/as.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -35,5 +35,5 @@
 #include <arch/mm/as.h>
 #include <arch/mm/tlb.h>
-#include <genarch/mm/as_ht.h>
+#include <genarch/mm/page_ht.h>
 #include <genarch/mm/asid_fifo.h>
 #include <debug.h>
Index: kernel/arch/sparc64/src/mm/memory_init.c
===================================================================
--- kernel/arch/sparc64/src/mm/memory_init.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/sparc64/src/mm/memory_init.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -35,5 +35,4 @@
 #include <arch/mm/memory_init.h>
 #include <arch/boot/boot.h>
-#include <typedefs.h>
 
 /** Return total size of available memory in bytes.
Index: kernel/arch/sparc64/src/mm/tlb.c
===================================================================
--- kernel/arch/sparc64/src/mm/tlb.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/sparc64/src/mm/tlb.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -45,5 +45,4 @@
 #include <print.h>
 #include <arch/types.h>
-#include <typedefs.h>
 #include <config.h>
 #include <arch/trap/trap.h>
Index: kernel/arch/sparc64/src/mm/tsb.c
===================================================================
--- kernel/arch/sparc64/src/mm/tsb.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/sparc64/src/mm/tsb.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -38,5 +38,4 @@
 #include <mm/as.h>
 #include <arch/types.h>
-#include <typedefs.h>
 #include <macros.h>
 #include <debug.h>
Index: kernel/arch/sparc64/src/smp/ipi.c
===================================================================
--- kernel/arch/sparc64/src/smp/ipi.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/sparc64/src/smp/ipi.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -35,4 +35,5 @@
 #include <smp/ipi.h>
 #include <cpu.h>
+#include <arch.h>
 #include <arch/cpu.h>
 #include <arch/asm.h>
Index: kernel/arch/sparc64/src/smp/smp.c
===================================================================
--- kernel/arch/sparc64/src/smp/smp.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/sparc64/src/smp/smp.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -43,5 +43,4 @@
 #include <synch/synch.h>
 #include <synch/waitq.h>
-#include <typedefs.h>
 #include <print.h>
 
Index: kernel/arch/sparc64/src/trap/exception.c
===================================================================
--- kernel/arch/sparc64/src/trap/exception.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/sparc64/src/trap/exception.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -41,5 +41,4 @@
 #include <arch/register.h>
 #include <debug.h>
-#include <typedefs.h>
 #include <symtab.h>
 #include <print.h>
Index: kernel/arch/sparc64/src/trap/interrupt.c
===================================================================
--- kernel/arch/sparc64/src/trap/interrupt.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/sparc64/src/trap/interrupt.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -34,8 +34,8 @@
 
 #include <arch/interrupt.h>
+#include <arch/sparc64.h>
 #include <arch/trap/interrupt.h>
 #include <interrupt.h>
 #include <ddi/irq.h>
-#include <typedefs.h>
 #include <arch/types.h>
 #include <debug.h>
Index: kernel/arch/sparc64/src/trap/syscall.c
===================================================================
--- kernel/arch/sparc64/src/trap/syscall.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/sparc64/src/trap/syscall.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -39,5 +39,4 @@
 #include <panic.h>
 #include <arch/types.h>
-#include <typedefs.h>
 
 unative_t syscall(int n, istate_t *istate, unative_t a1, unative_t a2, unative_t a3, unative_t a4)
Index: kernel/arch/sparc64/src/trap/trap.c
===================================================================
--- kernel/arch/sparc64/src/trap/trap.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/sparc64/src/trap/trap.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -44,5 +44,4 @@
 #include <debug.h>
 #include <arch/types.h>
-#include <typedefs.h>
 #include <arch/drivers/tick.h>
 
Index: kernel/genarch/include/kbd/i8042.h
===================================================================
--- kernel/genarch/include/kbd/i8042.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/genarch/include/kbd/i8042.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -36,5 +36,5 @@
 #define KERN_I8042_H_
 
-#include <typedefs.h>
+#include <console/chardev.h>
 
 extern void i8042_init(devno_t kbd_devno, inr_t kbd_inr, devno_t mouse_devno, inr_t mouse_inr);
Index: kernel/genarch/include/kbd/key.h
===================================================================
--- kernel/genarch/include/kbd/key.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/genarch/include/kbd/key.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -38,5 +38,5 @@
 
 #include <arch/types.h>
-#include <typedefs.h>
+#include <console/chardev.h>
 
 #define KEY_RELEASE     0x80
Index: kernel/genarch/include/kbd/ns16550.h
===================================================================
--- kernel/genarch/include/kbd/ns16550.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/genarch/include/kbd/ns16550.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -38,6 +38,6 @@
 #define KERN_NS16550_H_
 
-#include <typedefs.h>
-#include <ddi/irq.h>
+#include <console/chardev.h> 
+#include <ipc/irq.h>
 
 extern void ns16550_init(devno_t devno, inr_t inr, uintptr_t vaddr);
Index: kernel/genarch/include/kbd/z8530.h
===================================================================
--- kernel/genarch/include/kbd/z8530.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/genarch/include/kbd/z8530.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -38,6 +38,6 @@
 #define KERN_Z8530_H_
 
-#include <typedefs.h>
-#include <ddi/irq.h>
+#include <console/chardev.h>
+#include <ipc/irq.h>
 
 extern bool z8530_belongs_to_kernel;
Index: kernel/genarch/include/mm/as_ht.h
===================================================================
--- kernel/genarch/include/mm/as_ht.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/genarch/include/mm/as_ht.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -36,7 +36,53 @@
 #define KERN_AS_HT_H_
 
-#include <mm/as.h>
+#include <mm/mm.h>
+#include <arch/mm/asid.h>
+#include <adt/list.h>
+#include <adt/btree.h>
+#include <synch/mutex.h>
 
-extern as_operations_t as_ht_operations;
+/** Address space structure.
+ *
+ * as_t contains the list of as_areas of userspace accessible
+ * pages for one or more tasks. Ranges of kernel memory pages are not
+ * supposed to figure in the list as they are shared by all tasks and
+ * set up during system initialization.
+ */
+typedef struct {
+	/** Protected by asidlock. */
+	link_t inactive_as_with_asid_link;
+
+	mutex_t lock;
+
+	/** Number of references (i.e tasks that reference this as). */
+	count_t refcount;
+
+	/** Number of processors on wich is this address space active. */
+	count_t cpu_refcount;
+
+	/** B+tree of address space areas. */
+	btree_t as_area_btree;
+
+	/** Address space identifier. Constant on architectures that do not support ASIDs.*/
+	asid_t asid;
+	
+	/** Architecture specific content. */
+	as_arch_t arch;
+} as_t;
+
+typedef struct {
+	link_t link;		/**< Page hash table link. */
+	as_t *as;		/**< Address space. */
+	uintptr_t page;		/**< Virtual memory page. */
+	uintptr_t frame;	/**< Physical memory frame. */
+	unsigned g : 1;		/**< Global page. */
+	unsigned x : 1;		/**< Execute. */
+	unsigned w : 1;		/**< Writable. */
+	unsigned k : 1;		/**< Kernel privileges required. */
+	unsigned c : 1;		/**< Cacheable. */
+	unsigned a : 1;		/**< Accessed. */
+	unsigned d : 1;		/**< Dirty. */
+	unsigned p : 1;		/**< Present. */
+} pte_t;
 
 #endif
Index: kernel/genarch/include/mm/as_pt.h
===================================================================
--- kernel/genarch/include/mm/as_pt.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/genarch/include/mm/as_pt.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -36,7 +36,43 @@
 #define KERN_AS_PT_H_
 
-#include <mm/as.h>
+#include <mm/mm.h>
+#include <arch/mm/asid.h>
+#include <adt/list.h>
+#include <adt/btree.h>
+#include <synch/mutex.h>
 
-extern as_operations_t as_pt_operations;
+#define AS_PAGE_TABLE
+
+/** Address space structure.
+ *
+ * as_t contains the list of as_areas of userspace accessible
+ * pages for one or more tasks. Ranges of kernel memory pages are not
+ * supposed to figure in the list as they are shared by all tasks and
+ * set up during system initialization.
+ */
+typedef struct {
+	/** Protected by asidlock. */
+	link_t inactive_as_with_asid_link;
+
+	mutex_t lock;
+
+	/** Number of references (i.e tasks that reference this as). */
+	count_t refcount;
+
+	/** Number of processors on wich is this address space active. */
+	count_t cpu_refcount;
+
+	/** B+tree of address space areas. */
+	btree_t as_area_btree;
+	
+	/** Page table pointer. */
+	pte_t *page_table;
+
+	/** Address space identifier. Constant on architectures that do not support ASIDs.*/
+	asid_t asid;
+	
+	/** Architecture specific content. */
+	as_arch_t arch;
+} as_t;
 
 #endif
Index: kernel/genarch/include/mm/page_ht.h
===================================================================
--- kernel/genarch/include/mm/page_ht.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/genarch/include/mm/page_ht.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -40,8 +40,8 @@
 #define KERN_PAGE_HT_H_
 
+#include <arch/types.h>
+#include <mm/as.h>
 #include <mm/page.h>
 #include <synch/mutex.h>
-#include <arch/types.h>
-#include <adt/list.h>
 #include <adt/hash_table.h>
 
@@ -62,20 +62,7 @@
 #define SET_PTL0_ADDRESS(x)
 
-struct pte {
-	link_t link;		/**< Page hash table link. */
-	as_t *as;		/**< Address space. */
-	uintptr_t page;		/**< Virtual memory page. */
-	uintptr_t frame;	/**< Physical memory frame. */
-	unsigned g : 1;		/**< Global page. */
-	unsigned x : 1;		/**< Execute. */
-	unsigned w : 1;		/**< Writable. */
-	unsigned k : 1;		/**< Kernel privileges required. */
-	unsigned c : 1;		/**< Cacheable. */
-	unsigned a : 1;		/**< Accessed. */
-	unsigned d : 1;		/**< Dirty. */
-	unsigned p : 1;		/**< Present. */
-};
+extern as_operations_t as_ht_operations;
+extern page_mapping_operations_t ht_mapping_operations;
 
-extern page_mapping_operations_t ht_mapping_operations;
 extern mutex_t page_ht_lock;
 extern hash_table_t page_ht;
Index: kernel/genarch/include/mm/page_pt.h
===================================================================
--- kernel/genarch/include/mm/page_pt.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/genarch/include/mm/page_pt.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -45,5 +45,5 @@
 
 #include <arch/types.h>
-#include <typedefs.h>
+#include <mm/as.h>
 #include <mm/page.h>
 
@@ -108,4 +108,5 @@
 #define PTE_EXECUTABLE(p)	PTE_EXECUTABLE_ARCH((p))
 
+extern as_operations_t as_pt_operations;
 extern page_mapping_operations_t pt_mapping_operations;
 
Index: kernel/genarch/include/ofw/ofw_tree.h
===================================================================
--- kernel/genarch/include/ofw/ofw_tree.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/genarch/include/ofw/ofw_tree.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -31,5 +31,4 @@
 
 #include <arch/types.h>
-#include <typedefs.h>
 
 #define OFW_TREE_PROPERTY_MAX_NAMELEN	32
Index: kernel/genarch/src/acpi/madt.c
===================================================================
--- kernel/genarch/src/acpi/madt.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/genarch/src/acpi/madt.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -36,5 +36,4 @@
 
 #include <arch/types.h>
-#include <typedefs.h>
 #include <genarch/acpi/acpi.h>
 #include <genarch/acpi/madt.h>
Index: kernel/genarch/src/fb/fb.c
===================================================================
--- kernel/genarch/src/fb/fb.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/genarch/src/fb/fb.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -47,5 +47,4 @@
 #include <ddi/ddi.h>
 #include <arch/types.h>
-#include <typedefs.h>
 
 #include "helenos.xbm"
Index: kernel/genarch/src/kbd/i8042.c
===================================================================
--- kernel/genarch/src/kbd/i8042.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/genarch/src/kbd/i8042.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -45,10 +45,9 @@
 #include <arch/asm.h>
 #include <arch.h>
-#include <typedefs.h>
 #include <console/chardev.h>
 #include <console/console.h>
 #include <interrupt.h>
 #include <sysinfo/sysinfo.h>
-#include <ddi/irq.h>
+#include <ipc/irq.h>
 
 /* Keyboard commands. */
Index: kernel/genarch/src/kbd/key.c
===================================================================
--- kernel/genarch/src/kbd/key.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/genarch/src/kbd/key.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -45,5 +45,4 @@
 #include <synch/spinlock.h>
 #include <console/chardev.h>
-#include <typedefs.h>
 #include <macros.h>
 
Index: kernel/genarch/src/kbd/ns16550.c
===================================================================
--- kernel/genarch/src/kbd/ns16550.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/genarch/src/kbd/ns16550.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -46,5 +46,4 @@
 #include <arch/asm.h>
 #include <arch.h>
-#include <typedefs.h>
 #include <console/chardev.h>
 #include <console/console.h>
Index: kernel/genarch/src/kbd/z8530.c
===================================================================
--- kernel/genarch/src/kbd/z8530.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/genarch/src/kbd/z8530.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -48,5 +48,4 @@
 #include <arch/asm.h>
 #include <arch.h>
-#include <typedefs.h>
 #include <console/chardev.h>
 #include <console/console.h>
Index: kernel/genarch/src/mm/as_ht.c
===================================================================
--- kernel/genarch/src/mm/as_ht.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/genarch/src/mm/as_ht.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -36,4 +36,5 @@
  */
 
+#include <arch/mm/as.h>
 #include <genarch/mm/as_ht.h>
 #include <genarch/mm/page_ht.h>
@@ -41,5 +42,4 @@
 #include <mm/frame.h>
 #include <arch/types.h>
-#include <typedefs.h>
 #include <memstr.h>
 #include <adt/hash_table.h>
Index: kernel/genarch/src/mm/as_pt.c
===================================================================
--- kernel/genarch/src/mm/as_pt.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/genarch/src/mm/as_pt.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -44,5 +44,4 @@
 #include <arch/mm/as.h>
 #include <arch/types.h>
-#include <typedefs.h>
 #include <memstr.h>
 #include <arch.h>
Index: kernel/genarch/src/mm/asid_fifo.c
===================================================================
--- kernel/genarch/src/mm/asid_fifo.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/genarch/src/mm/asid_fifo.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -43,5 +43,4 @@
 #include <arch/mm/asid.h>
 #include <mm/asid.h>
-#include <typedefs.h>
 #include <adt/fifo.h>
 
Index: kernel/genarch/src/mm/page_ht.c
===================================================================
--- kernel/genarch/src/mm/page_ht.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/genarch/src/mm/page_ht.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -44,5 +44,4 @@
 #include <arch/mm/asid.h>
 #include <arch/types.h>
-#include <typedefs.h>
 #include <arch/asm.h>
 #include <synch/spinlock.h>
Index: kernel/genarch/src/mm/page_pt.c
===================================================================
--- kernel/genarch/src/mm/page_pt.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/genarch/src/mm/page_pt.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -43,5 +43,4 @@
 #include <arch/mm/as.h>
 #include <arch/types.h>
-#include <typedefs.h>
 #include <arch/asm.h>
 #include <memstr.h>
Index: kernel/generic/include/adt/bitmap.h
===================================================================
--- kernel/generic/include/adt/bitmap.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/generic/include/adt/bitmap.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -37,5 +37,4 @@
 
 #include <arch/types.h>
-#include <typedefs.h>
 
 #define BITS2BYTES(bits)	(bits ? ((((bits)-1)>>3)+1) : 0)
Index: kernel/generic/include/adt/btree.h
===================================================================
--- kernel/generic/include/adt/btree.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/generic/include/adt/btree.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -37,5 +37,4 @@
 
 #include <arch/types.h>
-#include <typedefs.h>
 #include <adt/list.h>
 
@@ -46,5 +45,5 @@
 
 /** B-tree node structure. */
-struct btree_node {
+typedef struct btree_node {
 	/** Number of keys. */
 	count_t keys;
@@ -66,8 +65,8 @@
 	 * There is room for storing a subtree pointer for the extra key.
 	 */
-	btree_node_t *subtree[BTREE_M + 1];
+	struct btree_node *subtree[BTREE_M + 1];
 
 	/** Pointer to parent node. Root node has NULL parent. */
-	btree_node_t *parent;
+	struct btree_node *parent;
 
 	/** Link connecting leaf-level nodes. Defined only when this node is a leaf. */
@@ -77,11 +76,11 @@
 	link_t bfs_link;
 	int depth;
-};
+} btree_node_t;
 
 /** B-tree structure. */
-struct btree {
+typedef struct {
 	btree_node_t *root;	/**< B-tree root node pointer. */
 	link_t leaf_head;	/**< Leaf-level list head. */
-};
+} btree_t;
 
 extern void btree_init(void);
Index: kernel/generic/include/adt/fifo.h
===================================================================
--- kernel/generic/include/adt/fifo.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/generic/include/adt/fifo.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -46,5 +46,4 @@
 #define KERN_FIFO_H_
 
-#include <typedefs.h>
 #include <mm/slab.h>
 
Index: kernel/generic/include/adt/hash_table.h
===================================================================
--- kernel/generic/include/adt/hash_table.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/generic/include/adt/hash_table.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -38,16 +38,7 @@
 #include <adt/list.h>
 #include <arch/types.h>
-#include <typedefs.h>
-
-/** Hash table structure. */
-struct hash_table {
-	link_t *entry;
-	count_t entries;
-	count_t max_keys;
-	hash_table_operations_t *op;
-};
 
 /** Set of operations for hash table. */
-struct hash_table_operations {
+typedef struct {
 	/** Hash function.
 	 *
@@ -71,5 +62,13 @@
 	 */
 	void (*remove_callback)(link_t *item);
-};
+} hash_table_operations_t;
+
+/** Hash table structure. */
+typedef struct {
+	link_t *entry;
+	count_t entries;
+	count_t max_keys;
+	hash_table_operations_t *op;
+} hash_table_t;
 
 #define hash_table_get_instance(item, type, member)	list_get_instance((item), type, member)
Index: kernel/generic/include/adt/list.h
===================================================================
--- kernel/generic/include/adt/list.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/generic/include/adt/list.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -37,11 +37,10 @@
 
 #include <arch/types.h>
-#include <typedefs.h>
 
 /** Doubly linked list head and link type. */
-struct link {
-	link_t *prev;	/**< Pointer to the previous item in the list. */
-	link_t *next;	/**< Pointer to the next item in the list. */
-};
+typedef struct link {
+	struct link *prev;	/**< Pointer to the previous item in the list. */
+	struct link *next;	/**< Pointer to the next item in the list. */
+} link_t;
 
 /** Declare and initialize statically allocated list.
Index: kernel/generic/include/arch.h
===================================================================
--- kernel/generic/include/arch.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/generic/include/arch.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -36,11 +36,6 @@
 #define KERN_ARCH_H_
 
-#include <arch/types.h>
 #include <arch/arch.h>
-#include <typedefs.h>
-
-#include <cpu.h>
-#include <arch/cpu.h>
-#include <arch/asm.h> 
+#include <proc/task.h>
 
 #define DEFAULT_CONTEXT		0
Index: kernel/generic/include/bitops.h
===================================================================
--- kernel/generic/include/bitops.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/generic/include/bitops.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -35,6 +35,4 @@
 #ifndef KERN_BITOPS_H_
 #define KERN_BITOPS_H_
-
-#include <typedefs.h>
 
 
Index: kernel/generic/include/config.h
===================================================================
--- kernel/generic/include/config.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/generic/include/config.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -37,5 +37,4 @@
 
 #include <arch/types.h>
-#include <typedefs.h>
 #include <arch/mm/page.h>
 
Index: kernel/generic/include/console/chardev.h
===================================================================
--- kernel/generic/include/console/chardev.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/generic/include/console/chardev.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -36,5 +36,4 @@
 #define KERN_CHARDEV_H_
 
-#include <typedefs.h>
 #include <arch/types.h>
 #include <synch/waitq.h>
@@ -43,17 +42,17 @@
 #define CHARDEV_BUFLEN 512
 
+struct chardev;
+
 /* Character device operations interface. */
-struct chardev_operations {
-	void (* suspend)(chardev_t *);		/**< Suspend pushing characters. */
-	void (* resume)(chardev_t *); 		/**< Resume pushing characters. */
-	void (* write)(chardev_t *, char c);	/**< Write character to stream. */
+typedef struct {
+	void (* suspend)(struct chardev *);		/**< Suspend pushing characters. */
+	void (* resume)(struct chardev *); 		/**< Resume pushing characters. */
+	void (* write)(struct chardev *, char c);	/**< Write character to stream. */
 	/** Read character directly from device, assume interrupts disabled */
-	char (* read)(chardev_t *); 
-};
-
-typedef struct chardev_operations chardev_operations_t;
+	char (* read)(struct chardev *); 
+} chardev_operations_t;
 
 /** Character input device. */
-struct chardev {
+typedef struct chardev {
 	char *name;
 	
@@ -65,5 +64,5 @@
 	index_t index;
 	void *data;
-};
+} chardev_t;
 
 extern void chardev_initialize(char *name,
Index: kernel/generic/include/console/cmd.h
===================================================================
--- kernel/generic/include/console/cmd.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/generic/include/console/cmd.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -36,5 +36,5 @@
 #define KERN_CMD_H_
 
-#include <typedefs.h>
+#include <console/kconsole.h>
 
 extern void cmd_initialize(cmd_info_t *cmd);
Index: kernel/generic/include/console/console.h
===================================================================
--- kernel/generic/include/console/console.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/generic/include/console/console.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -37,5 +37,5 @@
 
 #include <arch/types.h>
-#include <typedefs.h>
+#include <console/chardev.h>
 
 extern chardev_t *stdin;
Index: kernel/generic/include/console/kconsole.h
===================================================================
--- kernel/generic/include/console/kconsole.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/generic/include/console/kconsole.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -36,5 +36,4 @@
 #define KERN_KCONSOLE_H_
 
-#include <typedefs.h>
 #include <adt/list.h>
 #include <synch/spinlock.h>
@@ -43,13 +42,13 @@
 #define KCONSOLE_HISTORY 10
 
-enum cmd_arg_type {
+typedef enum {
 	ARG_TYPE_INVALID = 0,
 	ARG_TYPE_INT,
 	ARG_TYPE_STRING,
 	ARG_TYPE_VAR      /**< Variable type - either symbol or string */
-};
+} cmd_arg_type_t;
 
 /** Structure representing one argument of kconsole command line. */
-struct cmd_arg {
+typedef struct {
 	cmd_arg_type_t type;		/**< Type descriptor. */
 	void *buffer;			/**< Buffer where to store data. */
@@ -57,8 +56,8 @@
 	unative_t intval;                /**< Integer value */
 	cmd_arg_type_t vartype;         /**< Resulting type of variable arg */
-};
+} cmd_arg_t;
 
 /** Structure representing one kconsole command. */
-struct cmd_info {
+typedef struct {
 	link_t link;			/**< Command list link. */
 	SPINLOCK_DECLARE(lock);		/**< This lock protects everything below. */
@@ -69,5 +68,5 @@
 	cmd_arg_t *argv;		/**< Argument vector. */
 	void (* help)(void);		/**< Function for printing detailed help. */
-};
+} cmd_info_t;
 
 extern spinlock_t cmd_lock;
Index: kernel/generic/include/context.h
===================================================================
--- kernel/generic/include/context.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/generic/include/context.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -37,5 +37,4 @@
 
 #include <arch/types.h>
-#include <typedefs.h>
 #include <arch/context.h>
 
